package rip.iwakura.civil.commands;

import java.sql.SQLException;
import java.text.Format;

import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.checkerframework.common.reflection.qual.GetConstructor;

import com.mojang.brigadier.Command;
import com.mojang.brigadier.arguments.LongArgumentType;
import com.mojang.brigadier.arguments.StringArgumentType;
import com.mojang.brigadier.builder.LiteralArgumentBuilder;
import com.mojang.brigadier.tree.LiteralCommandNode;

import io.papermc.paper.command.brigadier.CommandSourceStack;
import io.papermc.paper.command.brigadier.Commands;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.NamedTextColor;
import net.kyori.adventure.text.format.TextDecoration;
import net.kyori.adventure.text.minimessage.MiniMessage;
import net.kyori.adventure.text.minimessage.translation.MiniMessageTranslator;
import rip.iwakura.civil.Core;
import rip.iwakura.civil.Database;
import rip.iwakura.civil.exceptions.InvalidChannelException;
import rip.iwakura.civil.types.*;

public class Spawn {
    private Core core;

    public Spawn(Core core) {
        this.core = core;
    }

    public LiteralCommandNode<CommandSourceStack> getCommand() {
        return Commands.literal("spawn")
                .requires(ctx -> ctx.getSender() instanceof Player)
                .executes(ctx -> {
                    Player p = (Player) ctx.getSource().getSender();

                    if (!core.getConfig().contains("spawn")) {
                        p.sendMessage(MiniMessage.miniMessage().deserialize("<red>The spawn has not been set yet."));
                        return 0;
                    }

                    p.teleport(core.getSpawn());

                    return Command.SINGLE_SUCCESS;
                })
                .then(Commands.literal("set").requires(
                        ctx -> ctx.getSender() instanceof Player && ctx.getSender().hasPermission("civil.spawn.set"))
                        .executes(ctx -> {
                            Player p = (Player) ctx.getSource().getSender();
                            Location loc = p.getLocation();

                            core.getConfig().set("spawn.world", loc.getWorld().getName());
                            core.getConfig().set("spawn.x", loc.x());
                            core.getConfig().set("spawn.y", loc.y());
                            core.getConfig().set("spawn.z", loc.z());
                            core.getConfig().set("spawn.yaw", loc.getYaw());
                            core.getConfig().set("spawn.pitch", loc.getPitch());

                            p.sendMessage(MiniMessage.miniMessage().deserialize("<green>Set the server spawn to your current position."));

                            return Command.SINGLE_SUCCESS;
                        }))
                .build();
    }

}
